OGRE: Ogre::RTShader::FunctionInvocation Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::RTShader::FunctionInvocation Class Reference
Optional Components » RTShaderSystem

A class that represents function invocation code from shader based program function. More...

`#include <OgreShaderFunctionAtom.h>`

Inheritance diagram for Ogre::RTShader::FunctionInvocation:
[legend]

## Classes
struct | FunctionInvocationCompare
| Comparator function to be used for comparisons. More...
struct | FunctionInvocationLessThan
| Comparator function to be used for sorting. More...

## Public Member Functions
| FunctionInvocation (const FunctionInvocation &rhs)
| Copy constructor.
| FunctionInvocation (const String &functionName, int groupOrder, const String &returnType="void")
| Class constructor.
const String & | getFunctionName () const
| Return the function name.
const String & | getReturnType () const
| Return the return type.
bool | operator!= (const FunctionInvocation &rhs) const
| Determines if the current object is not equal to the compared one.
bool | operator< (const FunctionInvocation &rhs) const
| Determines if the current object is less than the compared one.
bool | operator== (const FunctionInvocation &rhs) const
| Determines if the current object is equal to the compared one.
void | writeSourceCode (std::ostream &os, const String &targetLanguage) const override
Public Member Functions inherited from Ogre::RTShader::FunctionAtom
virtual | ~FunctionAtom ()
| Class default destructor.
int | getGroupExecutionOrder () const
| Get the group execution order of this function atom.
OperandVector & | getOperandList ()
| Get a list of parameters this function invocation will use in the function call as arguments.
void | pushOperand (ParameterPtr parameter, Operand::OpSemantic opSemantic, Operand::OpMask opMask=Operand::OPM_ALL, int indirectionLevel=0)
| Push a new operand (on the end) to the function.
void | setOperands (const OperandVector &ops)

## Additional Inherited Members
Public Types inherited from Ogre::RTShader::FunctionAtom
typedef std::vector< Operand > | OperandVector

## Detailed Description

A class that represents function invocation code from shader based program function.

## Constructor & Destructor Documentation

## ◆ FunctionInvocation() [1/2]

Ogre::RTShader::FunctionInvocation::FunctionInvocation | ( | const String & | functionName,
|  | int | groupOrder,
|  | const String & | returnType = "void" )

Class constructor.

Parameters

  functionName | The name of the function to invoke.
  groupOrder | The group order of this invocation.
  returnType | The return type of the used function.

Referenced by FunctionInvocation(), operator!=(), Ogre::RTShader::FunctionInvocation::FunctionInvocationCompare::operator()(), Ogre::RTShader::FunctionInvocation::FunctionInvocationLessThan::operator()(), operator<(), and operator==().

## ◆ FunctionInvocation() [2/2]

Ogre::RTShader::FunctionInvocation::FunctionInvocation | ( | const FunctionInvocation & | rhs | ) |

Copy constructor.

References FunctionInvocation().

## Member Function Documentation

## ◆ writeSourceCode()

void Ogre::RTShader::FunctionInvocation::writeSourceCode | ( | std::ostream & | os,
|  | const String & | targetLanguage ) const
| overridevirtual

See also
  FunctionAtom::writeSourceCode

Implements Ogre::RTShader::FunctionAtom.

## ◆ getFunctionName()

const String & Ogre::RTShader::FunctionInvocation::getFunctionName | ( |  | ) | const
| inline

Return the function name.

## ◆ getReturnType()

const String & Ogre::RTShader::FunctionInvocation::getReturnType | ( |  | ) | const
| inline

Return the return type.

## ◆ operator==()

bool Ogre::RTShader::FunctionInvocation::operator== | ( | const FunctionInvocation & | rhs | ) | const

Determines if the current object is equal to the compared one.

References FunctionInvocation().

## ◆ operator!=()

bool Ogre::RTShader::FunctionInvocation::operator!= | ( | const FunctionInvocation & | rhs | ) | const

Determines if the current object is not equal to the compared one.

References FunctionInvocation().

## ◆ operator<()

bool Ogre::RTShader::FunctionInvocation::operator< | ( | const FunctionInvocation & | rhs | ) | const

Determines if the current object is less than the compared one.

References FunctionInvocation().

The documentation for this class was generated from the following file:

- OgreShaderFunctionAtom.h